SystemOrganization addCategory: #'Twitter-Bootstrap-Magritte'!

MAValidationDecoration subclass: #TWBSMagritteValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteValidationDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 18:17'!
renderErrorsOn: html
	html break.
		
	html div
		class: 'alert';
		class: 'alert-error';
		with: [
			html anchor 
				class: 'close';
				attributeAt: 'data-dismiss' put: 'alert';
				with: [ html html: '&#215;' ].

			html strong: 'Please correct the following issues:'.
			html unorderedList
				class: 'errors';
				list: self errors;
				with: nil ]! !

MAFormDecoration subclass: #TWBSMagritteFormDecoration
	instanceVariableNames: 'formCss legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormDecoration class methodsFor: 'instance creation' stamp: 'NickAger 3/19/2012 21:07'!
newWithDefaultButtons
	^ self new 
		addButtons: #(save cancel);
		yourself! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss
	^ formCss! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/19/2012 15:35'!
formCss: anObject
	formCss := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend
	^ legend! !

!TWBSMagritteFormDecoration methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 17:39'!
legend: anObject
	legend := anObject! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 15:43'!
renderButtonsOn: html
	html div 
		class: 'form-actions'; 
		class: self formCss;
		with: [
			self buttons 
				do: [ :each |
					html button
						accessKey: each value first;
						class: 'btn';
						class: 'btn-primary' if: (each = buttons first);
						callback: [ self execute: each key ];
						text: each value ]
				separatedBy: [ html text: ' ' ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:40'!
renderContentOn: html
	html form
		class: 'magritte';
		class: self formCss;
		multipart: self requiresMultipartForm;
		defaultAction: [ self execute: self default ];
		with: [
			html fieldSet: [
				self renderLegendOn: html.
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

!TWBSMagritteFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 17:41'!
renderLegendOn: html
	self legend notNil ifTrue: [
		html legend: self legend ]! !

MACheckboxComponent subclass: #TWBSMagritteCheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteCheckboxComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:21'!
renderEditorOn: html
	html label
		class: 'checkbox';
		with: [
			html checkbox
				id: self labelId;
				disabled: self isReadonly;
				on: #value of: self.
			html space; render: self magritteDescription checkboxLabel ]! !

MAComponentRenderer subclass: #TWBSMagritteFormRenderer
	instanceVariableNames: 'validationMessagesInline formInline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteFormRenderer methodsFor: 'error handling' stamp: 'NickAger 3/9/2012 22:32'!
errorsForDescription: aDescription 
	^ component errors select: [ :anError | anError tag = aDescription ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline
	^ formInline ifNil: [ formInline := false ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/22/2012 11:07'!
formInline: anObject
	formInline := anObject! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/20/2012 13:34'!
renderComment:  aDescription
	aDescription comment notNil ifTrue: [
		html span
			class: 'help-inline';
			with: [
				html html: aDescription comment ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:13'!
renderContainer: aDescription
	self validationMessagesInline: aDescription twbsInlineValidationMessages.
	self formInline: aDescription twbsFormInline.
	self formInline ifTrue: [ html break ].
	
	super renderContainer: aDescription! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 13:40'!
renderControl: aDescription
	html render: (self childAt: aDescription)! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:09'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
		
	self formInline 
		ifTrue: [ self renderElementForInlineForm: aDescription ]
		ifFalse: [ 
			html div
				class: 'control-group';
				class: (self classFor: aDescription);
				with: [
					self renderLabel: aDescription.
					html div
						class: 'controls';
						 with: [ 			
							self renderControl: aDescription.
							self renderComment: aDescription.
							self validationMessagesInline ifTrue: [ self renderErrorSpan: aDescription ] ] ] ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:33'!
renderElementForInlineForm: aDescription
	html span
		class: 'control-group';
		class: (self classFor: aDescription);
		with: [
			self renderLabel: aDescription.
			html space.
			html span
				class: 'controls';
				 with: [ 			
					self renderControl: aDescription.
					html space.
					self renderComment: aDescription.
					self validationMessagesInline ifTrue: [  html space. self renderErrorSpan: aDescription ] ].
			html space ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/10/2012 00:10'!
renderErrorSpan: aDescription
	(self errorsForDescription: aDescription) do: [ :error |
		html span 
			class: 'help-inline';
			with: error ]! !

!TWBSMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 11:12'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label class: 'control-label'.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [ html html: aDescription label ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline
	^ validationMessagesInline ifNil: [ validationMessagesInline := true ]! !

!TWBSMagritteFormRenderer methodsFor: 'accessing' stamp: 'NickAger 3/20/2012 13:30'!
validationMessagesInline: anObject
	validationMessagesInline := anObject! !

MATextInputComponent subclass: #TWBSMagritteTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteTextInputComponent methodsFor: 'rendering' stamp: 'NickAger 3/19/2012 13:42'!
renderInputOn: html
	| textInput |
	textInput := html textInput.
	description placeholder notNil ifTrue: [ 
		textInput twbsPlaceholderText: description placeholder ].	
		
	textInput
		id: self labelId;
		on: #string of: self.! !

MARadioGroupComponent subclass: #TWBSMagritteRadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Magritte'!

!TWBSMagritteRadioGroupComponent class methodsFor: 'testing' stamp: 'NickAger 3/20/2012 11:37'!
isAbstract
	^ false! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 10:47'!
renderEditorOn: html
	| group |
	group := html radioGroup.
	html span
		id: self labelId;
		with: [
			self optionsWithIndexDo: [ :each :index |
				self renderOption: each
					index: index
					in: group
					on: html ]
				separatedBy: [ ] ]! !

!TWBSMagritteRadioGroupComponent methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 09:22'!
renderOption: anObject index: anInteger in: aRadioGroup on: html
	| optionId |
	optionId := self optionId: anInteger.
	html label
		class: 'radio';
		with: [
			html radioButton
				id: optionId;
				group: aRadioGroup;
				selected: self value = anObject;
				callback: [ self value: anObject ].
			html space.
			html text: (self labelForOption: anObject) ].


! !
